Index: BOL/script_install/creation_modipsl.sh
===================================================================
--- BOL/script_install/creation_modipsl.sh	(revision 4321)
+++ BOL/script_install/creation_modipsl.sh	(revision 4372)
@@ -2,13 +2,21 @@
 
 #set -vx
+unset LANG
 
 #####################################################################
 # Choix eventuel de la version : branche ou trunk et svn particuliere
+# Le script est lancé tous les soirs par un script sur lmdz-cq par lmdz
+# On peut aussi le relancé depuis la même machine en interactif
+# si le trusting de la nuit a échoué, soit que la raison soit extérieure
+# au modèle, soit qu'on fasse une correction svn entre temps :
+#   ./creation_modipsl.sh -force -latest 20221004 
+# où la dernière version ayant marché est 20221004.trunk
 #####################################################################
 
 branche=IPSLCM6.0.15
 branche=trunk
-rev="-r 4084"
+rev="-r 4370"
 rev=""
+latest="20221201"
 latest=""
 #latest=20210512 # Pour imposer de tester la convergence avec une version passee
@@ -106,8 +114,10 @@
 fi
 
+
 if [ "$latest" != "" ] ; then
    cd /home/users/lmdz/WWW/RESUBENCH/$branche/gfortran
    \rm -f latest
-   ln -s $latest latest
+   ln -s `pwd`/$latest latest
+   cd -
 fi
 
@@ -144,7 +154,19 @@
 #gzip -9 $modipsltar
 
+readme_file=Readme_LMDZ$version.md
+
+cat > $readme_file <<eod
+This model was downloaded from
+http://www.lmd.jussieu.fr/~lmdz/pub/src/modipsl.$version.tar.gz
+
+It was insalled with the \`install_lmdz.sh\` soft
+
+In order to see all the available versions, check
+http://www.lmd.jussieu.fr/~lmdz/pub/src/Readme
+
+``
+eod
+
 cd modipsl/modeles
-
-
 
 ###########################################################################
@@ -154,12 +176,14 @@
 echo Premier svn checkout $rev $svnmodel $LMDZ
 #ssh butler ' ( cd '`pwd`' ; svn checkout '$rev' '$svnmodel' '$LMDZ' ) '
+echo svn checkout $rev $svnmodel $LMDZ  
 svn checkout $rev $svnmodel $LMDZ  
-
-###########################################################################
-
-
-cd ../..
+svn info LMDZ   >> ../../$readme_file
+echo '``'       >> ../../$readme_file
+
+###########################################################################
+
+cd -
 echo $version
-tar cvf modipsl.$version.tar modipsl
+tar cvf modipsl.$version.tar modipsl $readme_file
 
 gzip modipsl.$version.tar
@@ -182,5 +206,5 @@
 
 if [ $check = 1 ] ; then
-   ./check_version.sh $version >| WORK/check.out.$version 2>&1
+   ./check_version.sh $version  >| WORK/check.out.$version 2>&1
    cat tmp.resu >> Correspondance
    cat tmp.resu >> LISMOI.$branche
@@ -189,10 +213,11 @@
 ### clean up of /tmp/lmdz if everything went smoothly
 ###
-##  grep -q 'OK	OK 	OK2	OK' tmp.resu
-##  RET=$?
-##  if [ ${RET} -eq 0 ] ; then
-##    echo "Quality control checks out for version $version"
-##    echo "We could cleanup /tmp/lmdz/LMDZ$version" 
-##    echo "\rm -rf /tmp/lmdz/LMDZ$version" 
-##  fi
-fi
+grep -q 'OK	OK 	OK2	OK' tmp.resu
+RET=$?
+   if [ ${RET} -eq 0 ] ; then
+      echo "Quality control checks out for version $version"
+      echo "We could cleanup /tmp/lmdz/LMDZ$version" 
+      echo "\rm -rf /tmp/lmdz/LMDZ$version" 
+      \rm -rf /tmp/lmdz/LMDZ$version
+   fi
+fi
Index: BOL/script_install/install_lmdz.sh
===================================================================
--- BOL/script_install/install_lmdz.sh	(revision 4321)
+++ BOL/script_install/install_lmdz.sh	(revision 4372)
@@ -212,5 +212,5 @@
                      *) echo Only none v1 v2 for cosp option ; exit
 		 esac ;;
-	"-nofcm") compile_with_fcm=0 ; shift ;;
+	"-nofcm") compile_with_fcm=0 ; echo This option will be reactivated soon '(promesse du 8dec2022)' ; exit 1 ;  shift ;;
 	"-SCM") SCM=1 ; shift ;;
 	"-opt_makelmdz") OPT_MAKELMDZ="$2" ; shift ; shift ;;
@@ -545,6 +545,6 @@
 
 
-echo '################################################################'
 if [ "$check_linux" = 1 ] ; then
+    echo '################################################################'
     echo   Check if required software is available
     echo '################################################################'
@@ -562,5 +562,5 @@
     fi
 
-    for logiciel in wget tar gzip make $compiler gcc cmake m4; do
+    for logiciel in wget tar gzip make $compiler gcc cmake m4 c++ ; do
 	if [ "`which $logiciel`" = "" ] ; then
 	    echo You must first install $logiciel on your system
@@ -1030,13 +1030,22 @@
     fi
     svn update $svnopt
-fi
-set -e
-
-##################################################################
+    set -e
+fi
+
+#---------------------------------------------------------------------
 # Retrieve the final svn release number, and adjust compilation
 # options accordingly
-mysvn=`svnversion . | egrep -o "[0-9]+"`
-
+# If svn not available, will use the svn writen in $MODEL/Readm*md
+# For old version it assumes that it is before 4185 (the version
+# for which the test was introduced
+#---------------------------------------------------------------------
+
+set +e ; mysvn=`svnversion . | egrep -o "[0-9]+" 2>/dev/null` ; set -e
+if [ "$mysvn" = "" ] ; then mysvn=`grep 'Revision: [0-9]' $MODEL/Read*.md | awk ' { print $2 } ' 2>/dev/null` ; fi
+if [ "$mysvn" = "" ] ; then mysvn=4190 ; fi
+
+#---------------------------------------------------------------------
 # Option de compilation du rayonnement : depend de $mysvn ><= r4185
+#---------------------------------------------------------------------
 opt_rad=""
 